local ci = LibStub( 'AceAddon-3.0'):GetAddon("CooldownIcons")

ci.IconUsage="Enter the Spellid here of the Spell you want to track the cooldown of.\nNote: Spellids can be found on i.e. Wowhead.com\ni.e. \"http://www.wowhead.com/?spell=1680\" is the Whirlwind link so 1680 is the Spellid of Whirlwind"

local function newIcon( n, rN, i)
	return { type='group', order=i, cmdHidden=true,
		name=function()
			if ci.db.char.layout[n].realname=="" and rN~=nil then
				return rN
			else
				return ci.db.char.layout[n].realname
			end
		end,
		args = {
			enable = { type='toggle', name='Enable Icon', desc='Enables/Disables the current Icon', order=1, width='full',
				get=function(i)
					return ci.db.char.layout[n].enabled
				end,
				set=function(i,v)
					local curIcon = getglobal ("CI_"..n)
					local curTex = getglobal ("CI_"..n.."_Texture")
					ci.db.char.layout[n].enabled =v
					if v then
						if curTex:GetTexture()~=ci.Icon_Nil then
							curIcon:Show()
						elseif curTex:GetTexture()==ci.Icon_Nil and ci.db.char.glob.enableConfig then
							curIcon:Show()
						else
							curIcon:Hide()
						end
					else
						curIcon:Hide()
					end
				end,
			},
			realname = { type='input', name="Name", order=2, width='full',
				get=function(i)
					return ci.db.char.layout[n].realname
				end,
				set=function(i,v)
					ci.db.char.layout[n].realname=v
				end,
			},
			id1 = { type='input', name="Spec 1", order=3, desc=ci.IconUsage,
				get=function(i)
					return ci.db.char.layout[n].id1
				end,
				set=function(i,v)
					ci.db.char.layout[n].id1 = v
					ci.db.char.layout[n].isItem=false
					if ci.db.char.layout[n].firstToSecond then
						ci.db.char.layout[n].id2=v
					end
					local curIcon = getglobal ("CI_"..n)
					local curTex = getglobal("CI_"..n.."_Texture")
					local _,_,newTex = GetSpellInfo(v)
					local w = ci.db.char.layout[n].id2
					local _,_,otherSpecTex = GetSpellInfo(w)
--					ci:Print(tostring(newTex)..", "..tostring(otherSpecTex))
					if ci.curTalentGroup==2 then
						if otherSpecTex~=nil then
							curTex:SetTexture(otherSpecTex)
							curIcon:Show()
						else
							curTex:SetTexture(ci.Icon_Nil)
							if ci.db.char.glob.enableConfig then
								curIcon:Show()
							else
								curIcon:Hide()
							end
						end
					else
						if newTex~=nil then
							curTex:SetTexture(newTex)
							curIcon:Show()
						else
							curTex:SetTexture(ci.Icon_Nil)
							if ci.db.char.glob.enableConfig then
								curIcon:Show()
							else
								curIcon:Hide()
							end
						end
					end
				end,
			},
			id2 = { type='input', name="Spec 2", order=4, desc=ci.IconUsage,
				get=function(i)
					if ci.db.char.layout[n].firstToSecond then
						ci.db.char.layout[n].id2 = ci.db.char.layout[n].id1
						return ci.db.char.layout[n].id1
					else
						return ci.db.char.layout[n].id2
					end
				end,
				set=function(i,v)
					ci.db.char.layout[n].id2 = v
					ci.db.char.layout[n].isItem=false
					local curIcon = getglobal ("CI_"..n)
					local curTex = getglobal("CI_"..n.."_Texture")
					local _,_,newTex = GetSpellInfo(v)
					local w = ci.db.char.layout[n].id1
					local _,_,otherSpecTex = GetSpellInfo(w)
					if ci.curTalentGroup==1 then
						if otherSpecTex~=nil then
							curTex:SetTexture(otherSpecTex)
							curIcon:Show()
						else
							curTex:SetTexture(ci.Icon_Nil)
							if ci.db.char.glob.enableConfig then
								curIcon:Show()
							else
								curIcon:Hide()
							end
						end
					else
						if newTex~=nil then
							curTex:SetTexture(newTex)
							curIcon:Show()
						else
							curTex:SetTexture(ci.Icon_Nil)
							if ci.db.char.glob.enableConfig then
								curIcon:Show()
							else
								curIcon:Hide()
							end
						end
					end
				end,
			},
			equalSpec = { type='toggle', name="Toggles EqualSpecs", 
				desc='If enabled, your second Spec will automaticly be the same Spell as your first.\nNote: Enabled this causes your \'Spec 2\' Edit-Bar to be useless.', order=5,
				get=function(i)
					return ci.db.char.layout[n].firstToSecond
				end,
				set=function(i,v)
					ci.db.char.layout[n].firstToSecond =v
					if v then
						ci.db.char.layout[n].id2 = ci.db.char.layout[n].id1
						local curIcon=getglobal("CI_"..n)
						local curTex=getglobal("CI_"..n.."_Texture")
						if ci.curTalentGroup==1 then
							local t = curTex:GetTexture()
							if t~=ci.Icon_Nil or ci.db.char.glob.enableConfig then
								curIcon:Show()
							else
								curIcon:Hide()
							end
						else
							if ci.db.char.layout[n].isItem then
								local _,_,_,_,_,_,_,_,_,newTex = GetItemInfo(ci.db.char.layout[n].id2)
								if newTex~=nil then
									curTex:SetTexture(newTex)
									curIcon:Show()
								else
									if ci.db.char.glob.enableConfig then
										curTex:SetTexture(ci.Icon_Nil)
										curIcon:Show()
									else
										curTex:SetTexture(ci.Icon_Nil)
										curIcon:Hide()
									end
								end
							else
								local _,_,newTex=GetSpellInfo(ci.db.char.layout[n].id2)
								if newTex~=nil then
									curTex:SetTexture(newTex)
									curIcon:Show()
								else
									curTex:SetTexture(ci.Icon_Nil)
									if ci.db.char.glob.enableConfig then
										curIcon:Show()
									else
										curIcon:Hide()
									end
								end
							end
						end
					end
				end,
			},
			spelloritem = {type='toggle',name='Toggle Item',desc='Determinates if given name or id is an item.',order=6, 
				get=function(i)
					return ci.db.char.layout[n].isItem
				end,
				set=function(i,v)
					ci.db.char.layout[n].isItem=v
					--update current Icons to Items
					local curIcon= getglobal("CI_"..n)
					local curTex = getglobal("CI_"..n.."_Texture")
					local newTex = nil
					if v then
						if ci.curTalentGroup==1 then
							local w = ci.db.char.layout[n].id1
							if (string.find(w,"#")==1) then
								local invID = ci:equip_transferFlagToSpellName(w)
								newTex=GetInventoryItemTexture("player",invID)
							else
								_,_,_,_,_,_,_,_,_,newTex = GetItemInfo(w)
							end
							if newTex~=nil then
								curTex:SetTexture(newTex)
								curIcon:Show()
							else
								curTex:SetTexture(ci.Icon_Nil)
								if ci.db.char.glob.enableConfig then
									curIcon:Show()
								else
									curIcon:Hide()
								end
							end
						else
							local w = ci.db.char.layout[n].id2
							if (string.find(w,"#")==1) then
								local invID = ci:equip_transferFlagToSpellName(w)
								newTex=GetInventoryItemTexture("player",invID)
							else
								_,_,_,_,_,_,_,_,_,newTex = GetItemInfo(w)
							end
							if newTex~=nil then
								curTex:SetTexture(newTex)
								curIcon:Show()
							else
								curTex:SetTexture(ci.Icon_Nil)
								if ci.db.char.glob.enableConfig then
									curIcon:Show()
								else
									curIcon:Hide()
								end
							end
						end
					else
						if ci.curTalentGroup==1 then
							local w = ci.db.char.layout[n].id1
							_,_,newTex = GetSpellInfo(w)
							if newTex~=nil then
								curTex:SetTexture(newTex)
								curIcon:Show()
							else
								curTex:SetTexture(ci.Icon_Nil)
								if ci.db.char.glob.enableConfig then
									curIcon:Show()
								else
									curIcon:Hide()
								end
							end
						else
							local w = ci.db.char.layout[n].id2
							_,_,newTex = GetSpellInfo(w)
							if newTex~=nil then
								curTex:SetTexture(newTex)
								curIcon:Show()
							else
								curTex:SetTexture(ci.Icon_Nil)
								if ci.db.char.glob.enableConfig then
									curIcon:Show()
								else
									curIcon:Hide()
								end
							end
						end
					end
				end,
			},
			zoomToggle = { type='toggle', name="Toggle Zoom",desc='Enables/Disables zoomed Icon' ,order=7, width='full',
				get=function(i)
					return ci.db.char.layout[n].zoomToggle
				end,
				set=function(i,v)
					ci.db.char.layout[n].zoomToggle = v
					local curTex = getglobal ("CI_"..n.."_Texture")
					if v then
						curTex:SetTexCoord(0.08,0.92,0.08,0.92)
					else
						curTex:SetTexCoord(0,1,0,1)
					end
				end,
			},
			grayToggle = { type='toggle', name="Toggle outgraying",
				desc='If enabled, the icon will gray out if it is on cooldown.', order=8, width='full',
				get=function(i)
					return ci.db.char.layout[n].grayToggle
				end,
				set=function(i,v)
					ci.db.char.layout[n].grayToggle = v
					local curTex = getglobal ("CI_"..n.."_Texture")
					if not v then
						curTex:SetDesaturated(0)
					end
				end,
			},
			rng = { type='toggle', name='Toggle Range check', 
				desc='Toggles if you want to check that your target is in range for that Spell.',order=9,
				get=function(i)	
					return ci.db.char.layout[n].rangeCheck
				end,
				set=function(i,v)
					ci.db.char.layout[n].rangeCheck=v
					if not v then
						getglobal("CI_"..n.."_Texture"):SetVertexColor(1,1,1,1)
					end
				end,
			},
			timeFormat = { type='select', name='Select Time format',
				desc='Format, Example', order=10, values={ "Seconds,81","Minute:Seconds,1:21","Minutes, 2m"},
				get=function(i)
					return ci.db.char.layout[n].timeFormat
				end,
				set=function(i,v)
					ci.db.char.layout[n].timeFormat=v
				end,
			},
			displayStyle= { type='select', name="Select Display Style",desc="Changes the behaviour of the current Icon.", order=11, 
				values={ "Show always","Hide Icons on Cooldown","Hide Icons when ready"},
				get=function(i)
					return ci.db.char.layout[n].displayStyle
				end,
				set=function(i,v)
					ci.db.char.layout[n].displayStyle=v
					local curIcon=getglobal("CI_"..n)
					local curTex=getglobal("CI_"..n.."_Texture")
					local t = curTex:GetTexture()
					if v==1 then
						if ci.db.char.glob.enableConfig then
							curIcon:Show()
						elseif ci.db.char.layout[n].enabled then
							if t~=ci.Icon_Nil then
								curIcon:Show()
							else
								curIcon:Hide()
							end
						else
							curIcon:Hide()
						end
					elseif v==2 then
						if ci.db.char.glob.enableConfig then
							curIcon:Show()
						elseif ci.db.char.layout[n].enabled then
							if t~=ci.Icon_Nil then
								curIcon:Show()
							else
								curIcon:Hide()
							end
						else
							curIcon:Hide()
						end
					elseif v==3 then
						if ci.db.char.glob.enableConfig then
							curIcon:Show()
						elseif ci.db.char.layout[n].enabled then
							if t~=ci.Icon_Nil then
								curIcon:Show()
							else
								curIcon:Hide()
							end
						else
							curIcon:Hide()
						end
					end
				end,
			},
			xOffset = { type='range', name='x Offset from Middle of Screen', width='full', min=-2000, max=2000, step=1, order=12,
				get=function(i)
					return ci.db.char.layout[n].x
				end,
				set=function(i,v)
					local curIcon = getglobal ("CI_"..n)
					ci.db.char.layout[n].x = v
					curIcon:SetPoint("Center",ci.frame,"Center",v,ci.db.char.layout[n].y)
				end,
			},
			yOffset = { type='range', name='y-Offset from Middle of Screen', width='full', min=-2000, max=2000, step=1, order=13,
				get=function(i)
					return ci.db.char.layout[n].y
				end,
				set=function(i,v)
					local curIcon = getglobal ("CI_"..n)
					ci.db.char.layout[n].y = v
					curIcon:SetPoint("Center",ci.frame,"Center",ci.db.char.layout[n].x,v)
				end,
			},
			buttonSize = { type='range', name='Icon size', width='full', min=2, max=512, step=1,order=14,
				get=function(i)
					return ci.db.char.layout[n].iconSize
				end,
				set=function(i,v)
					local curIcon = getglobal ("CI_"..n)
					local curTex = getglobal ("CI_"..n.."_Texture")
					ci.db.char.layout[n].iconSize=v
					curIcon:SetHeight(v)
					curIcon:SetWidth(v)
					curTex:SetAllPoints(curIcon)
				end,
			},
			fontSize = { type='range', name='Fontsize', desc='Changes the fontsize of the current icon',width='full',min=1,max=256,step=1,order=15,
				get=function(i)
					return ci.db.char.layout[n].fontsize
				end,
				set=function(i,v)
					ci.db.char.layout[n].fontsize=v
					local curText=getglobal("CI_"..n.."_time")
					curText:SetFont("Fonts\\FRIZQT__.TTF",v,"OUTLINE")
				end,
			},
		},
	}
end

local options = { type='group',handler=ci,name='CooldownIcons',
	args = {
		general = { type='group', name='CooldownIcons', inline=true, 
			args = {
				reversion = { type='description', name=ci.ver, order=1, cmdHidden=true,},
				description = { type='description', name="Tracks and Displays your choosen Cooldowns in a smart way.", order=2, cmdHidden=true,},
				glob = { type='group', name ='Global Icon Settings',inline=true,
				args= {
					enConfig = { type='toggle', name='Toggle Config', desc='QuestionMarks are shown if enabled. Otherwise they are hidden.\nMeans no entry icon will hide for that spec.', width='full',order=1,
						get=function(i)
							return ci.db.char.glob.enableConfig
						end,
						set=function(i,v)
							ci.db.char.glob.enableConfig=v
							for i=1,ci.icons do
								local act="icon"..i
								local curIcon=getglobal("CI_"..act)
								local curTex=getglobal("CI_"..act.."_Texture")
								if v then 
									if ci.db.char.layout[act].enabled then
										if curTex:GetTexture()==nil then
											curTex:SetTexture(ci.Icon_Nil)
										end
										curIcon:Show()
									elseif not curIcon:IsVisible() then
										curIcon:Hide()
									end
								else
									if curTex:GetTexture()==ci.Icon_Nil then
										curIcon:Hide()
									elseif ci.db.char.layout[act].enabled then
										curIcon:Show()
									end
								end
							end
						end,						
					},
					buttonSize = { type='range', name='Global Icon Size', width='full', min=2, max=512, step=2, order=98,
						get=function(i)
							return ci.db.char.glob.iconSize
						end,
						set=function(i,v)
							ci.db.char.glob.iconSize=v
							for i=1,ci.icons do
								local act = "icon"..i
								local curIcon=getglobal("CI_"..act)
								curIcon:SetHeight(v)
								curIcon:SetWidth(v)
								ci.db.char.layout[act].iconSize = v
							end
						end,
						},
					zoomToggle = { type='toggle', name='Toggle Zoom for all icons', width='full', desc='Enables/Disables global zoomed Icon\nNote:If you uncheck previous state will take place.',order=3,
						get=function(i)
							return ci.db.char.glob.zoomToggle
						end,
						set=function(i,v)
							ci.db.char.glob.zoomToggle=v
							for i=1,ci.icons do
								local act="icon"..i
								local curTex=getglobal("CI_"..act.."_Texture")
								if v then
									curTex:SetTexCoord(0.08,0.92,0.08,0.92)
								else
									if ci.db.char.layout[act].zoomToggle then
										curTex:SetTexCoord(0.08,0.92,0.08,0.92)
									else
										curTex:SetTexCoord(0,1,0,1)
									end
								end
							end
						end,
						},
					grayToggle = { type='toggle', name='Toggle outgraying',desc='If enabled, all icons will gray out if the spell is on cooldown.',width='full',order=9,
						get=function(i)
							return ci.db.char.glob.grayToggle
						end,
						set=function(i,v)
							ci.db.char.glob.grayToggle=v
							for i=1,ci.icons do
								local act="icon"..i
								local curTex=getglobal("CI_"..act.."_Texture")
								if not v then
									curTex:SetDesaturated(0)
								end
							end
						end,
						},
					fontSize = { type='range', name='Global Fontsize', desc='Changes the fontsize of all icons', min=1, max=256, step=1,width='full',order=100,
							get=function(i)
								return ci.db.char.glob.fontsize
							end,
							set=function(i,v)
								ci.db.char.glob.fontsize=v
								for i=1,ci.icons do
									local act="icon"..i
									local curText=getglobal("CI_"..act.."_time")
									curText:SetFont("Fonts\\FRIZQT__.TTF",v,"OUTLINE")
									ci.db.char.layout[act].fontsize = v
								end
							end,
						},
					displayStyle= {type='select', name='Select Display Style',desc='Changes the behaviours of all icons\nNote:\'Hide Icons when ready\' is not useful for configuration.', order=8, values={ "Show always","Hide Icons on Cooldown","Hide Icons when ready"},
						get=function(i)
							return ci.db.char.glob.displayStyle
						end,
						set=function(i,v)
							ci.db.char.glob.displayStyle=v
							for i=1,ci.icons do
								local act="icon"..i
								ci.db.char.layout[act].displayStyle=v
								local curIcon=getglobal("CI_"..act.."_Texture")
								if v==1 then
									curIcon:Show()
								elseif v==2 then
									curIcon:Show()
								end
							end
						end,
						},
					}, 
				},
			},
		},
		layout = { type='group', name="Icon Layouts", order=3, cmdHidden=true, 
			args = {
				icon1 = newIcon( "icon1","Icon1",101),
				icon2 = newIcon( "icon2","Icon2",102),
				icon3 = newIcon( "icon3","Icon3",103),
				icon4 = newIcon( "icon4","Icon4",104),
				icon5 = newIcon( "icon5","Icon5",105),
				icon6 = newIcon( "icon6","Icon6",106),
				icon7 = newIcon( "icon7","Icon7",107),
				icon8 = newIcon( "icon8","Icon8",108),
				icon9 = newIcon( "icon9","Icon9",109),
				icon10 = newIcon( "icon10","Icon10",110),
				icon11 = newIcon( "icon11","Icon11",111),
				icon12 = newIcon( "icon12","Icon12",112),
				icon13 = newIcon( "icon13","Icon13",113),
				icon14 = newIcon( "icon14","Icon14",114),
				icon15 = newIcon( "icon15","Icon15",115),
				icon16 = newIcon( "icon16","Icon16",116),
				icon17 = newIcon( "icon17","Icon17",117),
				icon18 = newIcon( "icon18","Icon18",118),
				icon19 = newIcon( "icon19","Icon19",119),
				icon20 = newIcon( "icon20","Icon20",120),
				icon21 = newIcon( "icon21","Icon21",121),
				icon22 = newIcon( "icon22","Icon22",122),
				icon23 = newIcon( "icon23","Icon23",123),
				icon24 = newIcon( "icon24","Icon24",124),
				icon25 = newIcon( "icon25","Icon25",125),
				icon26 = newIcon( "icon26","Icon26",126),
				icon27 = newIcon( "icon27","Icon27",127),
				icon28 = newIcon( "icon28","Icon28",128),
				icon29 = newIcon( "icon29","Icon29",129),
				icon30 = newIcon( "icon30","Icon30",130),
				icon31 = newIcon( "icon31","Icon31",131),
				icon32 = newIcon( "icon32","Icon32",132),
				icon33 = newIcon( "icon33","Icon33",133),
				icon34 = newIcon( "icon34","Icon34",134),
				icon35 = newIcon( "icon35","Icon35",135),
				icon36 = newIcon( "icon36","Icon36",136),
				icon37 = newIcon( "icon37","Icon37",137),
				icon38 = newIcon( "icon38","Icon38",138),
				icon39 = newIcon( "icon39","Icon39",139),
				icon40 = newIcon( "icon40","Icon40",140),
				icon41 = newIcon( "icon41","Icon41",141),
				icon42 = newIcon( "icon42","Icon42",142),
				icon43 = newIcon( "icon43","Icon43",143),
				icon44 = newIcon( "icon44","Icon44",144),
				icon45 = newIcon( "icon45","Icon45",145),
				icon46 = newIcon( "icon46","Icon46",146),
				icon47 = newIcon( "icon47","Icon47",147),
				icon48 = newIcon( "icon48","Icon48",148),
				icon49 = newIcon( "icon49","Icon49",149),
				icon50 = newIcon( "icon50","Icon50",150),
			},
		},
	},
}

local function OnCommand( input)
	if input and (input:trim()=='config' or input:trim()=='c') then
		InterfaceOptionsFrame_OpenTocategory( 'CooldownIcons')
	else
		InterfaceOptionsFrame_OpenToCategory( 'CooldownIcons')
	end
end


function ci:InitConfig()
	LibStub('AceConfig-3.0'):RegisterOptionsTable( 'ci', options)
	local dialog = LibStub( 'AceConfigDialog-3.0')
	dialog:AddToBlizOptions("ci", "CooldownIcons", nil, "general")
	dialog:AddToBlizOptions("ci", "Icon Layout", "CooldownIcons", "layout")
	self:RegisterChatCommand( 'cooldownicons', OnCommand)
	self:RegisterChatCommand( 'ci', OnCommand)
end





