-- Ace3 Load
local ci = LibStub("AceAddon-3.0"):NewAddon("CooldownIcons", "AceConsole-3.0","AceEvent-3.0")

local defaults = {
	char = {
		glob = {
			enabled = "",
			zoomToggle=true,
			grayToggle=true,
			firstToSecond=false,
			timeFormat=1,
			y = 0,
			iconSize=32,
			fontsize=12,
			displayStyle=1,
			enableConfig=true,
		},
		layout = {
			['*'] =	{ 
				realname="",
				enabled = false,
				id1=0,
				id2=0,
				zoomToggle=true,
				grayToggle=true,
				firstToSecond=false,
				timeFormat=1,
				x = 0,
				y = 0,
				iconSize=32,
				fontsize=12,
				displayStyle=1,
				isItem = false,
				rangeCheck = false,
			},
		},
	},
}
local accuracy = 10;

local flags = {
	--vehicle
}
--equip
flags.equip = {
    [0]="#ammo",
    [1]="#head",
    [2]="#neck",
    [3]="#shoulder",
    [4]="#shirt",
    [5]="#chest",
    [6]="#belt",
    [7]="#legs",
    [8]="#feet",
    [9]="#wrist",
    [10]="#gloves",
    [11]="#finger1",
    [12]="#finger2",
    [13]="#trinket1",
    [14]="#trinket2",
    [15]="#back",
    [16]="#mainhand",
    [17]="#offhand",
    [18]="#ranged",
    [19]="#tabard",
}

ci.debug = false

ci.ver = format( "v%s %s(%s)%s", GetAddOnMetadata( 'CooldownIcons', 'Version') or 'unknown', RED_FONT_COLOR_CODE, 'WotLK', FONT_COLOR_CODE_CLOSE)
--Init new UIParent (for this addon)
ci.frame = CreateFrame("Frame","CooldownIcons_Frame",UIParent)
ci.frame:SetAllPoints(UIParent)

ci.gcd = 1.5
ci.update = 0.5
ci.lastUpdate = 0
ci.player_logged_in = false
ci.curTalentGroup = 1
ci.btnsCreated = false
ci.Icon_Nil = "Interface\\Icons\\INV_Misc_QuestionMark"
ci.icons = 50
local floor = math.floor
local tonumber = tonumber

ci.Updater = CreateFrame("Frame","CI_Updater",UIParent)
ci.Updater:SetScript("OnUpdate", function()
	local now = GetTime()
	if (now-ci.lastUpdate)>ci.update and ci.player_logged_in then
		for i=1,ci.icons do
			local act = "icon"..i
			if ci.db.char.layout[act].enabled then
				local actDisplayStyle = ci.db.char.layout[act].displayStyle
				local spell1 = ci.db.char.layout[act].id1
				local spell2 = ci.db.char.layout[act].id2
				local rCheck = ci.db.char.layout[act].rangeCheck
				local timeFormat = ci.db.char.layout[act].timeFormat
				local name = ""
				local isAnID=nil
				local unit="target"
				local start,duration,enabled
				local starti,durationi,enabledi
				local curIsItem = ci.db.char.layout[act].isItem
				local curIcon = getglobal ("CI_"..act)
				local curText = getglobal ( "CI_"..act.."_time" )
				local curTex = getglobal ( "CI_"..act.."_Texture")
				if ci.curTalentGroup==1 and spell1~=0 then
					local tmp = tonumber(spell1)
					if tmp~=nil then
						isAnID=true
						if curIsItem then
							start,duration,enabled = GetItemCooldown(spell1)
						else
							name = GetSpellInfo(tmp)
							start,duration,enabled = GetSpellCooldown(name)
						end
					else
						isAnID=false
						if curIsItem then
							if (string.find(spell1,"#")==1) then
								local invID = ci:equip_transferFlagToSpellName(spell1)
								start,duration,enabled = GetInventoryItemCooldown("player",invID)
							else
								start,duration,enabled = GetItemCooldown(spell1)
							end
						else							
							start,duration,enabled = GetSpellCooldown(spell1)
						end
					end
				elseif ci.curTalentGroup==2 and spell2~=0 then
					local tmp = tonumber(spell2)
					if tmp~=nil then
						isAnID=true
						name = GetSpellInfo(tmp)
						if curIsItem then
							start,duration,enabled = GetItemCooldown(spell2)
						else
							start,duration,enabled = GetSpellCooldown(name)
						end						
					else
						isAnID=false
						if curIsItem then
							if (string.find(spell1,"#")==1) then
								local invID = ci:equip_transferFlagToSpellName(spell2)
								start,duration,enabled = GetInventoryItemCooldown("player",invID)
							else
								start,duration,enabled = GetItemCooldown(spell1)
							end
						else
							start,duration,enabled = GetSpellCooldown(spell2)
						end
					end
				end
				if start ~=nil then
					if start>0 and duration>ci.gcd then
						if actDisplayStyle==2 then
							curIcon:Hide()
							curText:SetText("")
						else
							if not curIcon:IsVisible() then
								curIcon:Show()
							end
							local t = duration-((floor((now-start)*accuracy))/accuracy)
							--local tx = ((floor((now-start)*accuracy))/accuracy)
							if ci.db.char.layout[act].grayToggle or ci.db.char.glob.grayToggle then
								curTex:SetDesaturated(1)
							end
							if timeFormat==1 then
								local t1, t2= strsplit(".", t)
								if t2==nil then
									t2 = 0
								end
								ts = t1.."."..t2
								curText:SetText(ts)
							elseif timeFormat==2 then
								local m = floor(t/60)
								local s = floor(t-(m*60))
								if m>=0 and s>9 then curText:SetText(m..":"..s)
								elseif s>=0 then curText:SetText(m..":0"..s)
								end
							elseif timeFormat==3 then
								local m = floor(t/60)
								local s = t-(t*m)
								if m>0 then curText:SetText(m.."m")
								else curText:SetText(s)
								end
							end
						end
					else 
						if actDisplayStyle==1 then
							if ci.db.char.layout[act].grayToggle then
								curTex:SetDesaturated(0)
							end
							curText:SetText("")
						elseif actDisplayStyle==2 then
							if ci.db.char.layout[act].grayToggle then
								curTex:SetDesaturated(0)
							end
							curIcon:Show()
							curText:SetText("")
						elseif actDisplayStyle==3 then
							curIcon:Hide()
							curText:SetText("")
						end
					end
				end
				if rCheck then
					if UnitExists(unit) then
						if ci.curTalentGroup==1 then
							if curIsItem then
								if ItemHasRange(spell1) then
									local inRange = IsItemInRange(spell1,unit)
									if inRange==0 then
										curTex:SetVertexColor(1,0,0,1)
									else
										curTex:SetVertexColor(1,1,1,1)
									end
								else
									curTex:SetVertexColor(1,1,1,1)
								end
							else
								if SpellHasRange(spell1) then
									if isAnID then
										local sName = GetSpellInfo(spell1)
										local inRange = IsSpellInRange(sName,unit)
										if inRange==0 then
											curTex:SetVertexColor(1,0,0,1)
										else
											curTex:SetVertexColor(1,1,1,1)
										end
									else
										local inRange = IsSpellInRange(spell1,unit)
										if inRange==0 then
											curTex:SetVertexColor(1,0,0,1)
										else
											curTex:SetVertexColor(1,1,1,1)
										end
									end
								else
									curTex:SetVertexColor(1,1,1,1)
								end
							end
						else
							if curIsItem then
								if ItemHasRange(spell2) then
									local inRange = IsItemInRange(spell2,unit)
									if inRange==0 then
										curTex:SetVertexColor(1,0,0,1)
									else
										curTex:SetVertexColor(1,1,1,1)
									end
								else
									curTex:SetVertexColor(1,1,1,1)
								end
							else
								if SpellHasRange(spell2) then
									if isAnID then
										local sName = GetSpellInfo(spell2)
										local inRange = IsSpellInRange(sName,unit)
										if inRange==0 then
											curTex:SetVertexColor(1,0,0,1)
										else
											curTex:SetVertexColor(1,1,1,1)
										end
									else
										local inRange = IsSpellInRange(spell2,unit)
										if inRange==0 then
											curTex:SetVertexColor(1,0,0,1)
										else
											curTex:SetVertexColor(1,1,1,1)
										end
									end
								else
									curTex:SetVertexColor(1,1,1,1)
								end
							end
						end
					else
						curTex:SetVertexColor(1,1,1,1)
					end
				end
	--Enable-If ends here
			end
--For-Loop ends here
		end		
	end
end)

function ci:OnInitialize()
	self.db = LibStub("AceDB-3.0"):New("CooldownIconsCharDB", defaults, "Default")
	ci:InitConfig()
end
function ci:OnEnable()
	self:Print(ci.ver.." loaded!")
	self:RegisterEvent("PLAYER_ENTERING_WORLD")
	self:RegisterEvent("ACTIVE_TALENT_GROUP_CHANGED")
	self:RegisterEvent("UNIT_INVENTORY_CHANGED")
end
function ci:OnDisable()
end

function ci:UNIT_INVENTORY_CHANGED()
	
end

function ci:PLAYER_ENTERING_WORLD()
	ci.curTalentGroup = GetActiveTalentGroup()
	if not (ci.player_logged_in) and not (ci.btnsCreated) then
		self:CreateIcons()
	end
	ci.player_logged_in=true
end
function ci:CreateIcons()
	for i=1,ci.icons do
		local iconT = ci.Icon_Nil
		local act = "icon"..i
		local spell1 = self.db.char.layout[act].id1
		local spell2 = self.db.char.layout[act].id2
		local truthCheck = (spell1==0 and spell2==0) or (spell1 == "" and spell2 == "")
		if truthCheck then
			iconT = ci.Icon_Nil
		elseif (ci.curTalentGroup == 1 or self.db.char.layout[act].firstToSecond) and not truthCheck  then
			if not ci.db.char.layout[act].isItem then
				_,_,iconT = GetSpellInfo(spell1)
			else 
				if (string.find(spell1,"#")==1) then
					local invID = ci:equip_transferFlagToSpellName(spell1)
					iconT=GetInventoryItemTexture("player",invID)
				else
					_,_,_,_,_,_,_,_,_, iconT = GetItemInfo(spell1)
				end
			end
			if iconT==nil then iconT = ci.Icon_Nil end
		elseif ci.curTalentGroup==2 and not self.db.char.layout[act].firstToSecond and not truthCheck then
			if not ci.db.char.layout[act].isItem then
				_,_,iconT = GetSpellInfo(spell2)
			else 
				if (string.find(spell2,"#")==1) then
					local invID = ci:equip_transferFlagToSpellName(spell2)
					iconT=GetInventoryItemTexture("player",invID)
				else
					_,_,_,_,_,_,_,_,_, iconT = GetItemInfo(spell2)
				end
			end
			if iconT==nil then iconT = ci.Icon_Nil end
		else iconT = ci.Icon_Nil
		end
		local iconNr = "CI_"..act
		local act_X = self.db.char.layout[act].x
		local act_Y = self.db.char.layout[act].y
		local icon = CreateFrame("Frame",iconNr,ci.frame)
		icon:SetHeight(self.db.char.layout[act].iconSize)
		icon:SetWidth(self.db.char.layout[act].iconSize)
		icon:SetPoint("CENTER",ci.frame,"CENTER",act_X,act_Y)
		icon.tex = icon:CreateTexture(iconNr.."_Texture")
		icon.tex:SetAllPoints(icon)
		icon.tex:SetTexture(iconT)
		if self.db.char.glob.zoomToggle then
			icon.tex:SetTexCoord(0.08, 0.92, 0.08, 0.92)
		else
			if self.db.char.layout[act].zoomToggle then
				icon.tex:SetTexCoord(0.08, 0.92, 0.08, 0.92)
			end
		end
		icon:SetFrameStrata("LOW")
		icon.time = icon:CreateFontString(iconNr.."_time", "ARTWORK")
		icon.time:SetPoint("CENTER", icon, "CENTER", 0, 1)
		icon.time:SetFont("Fonts\\FRIZQT__.TTF",ci.db.char.layout[act].fontsize,"OUTLINE")
		icon.time:SetTextColor(1, 1, 0)
		icon.time:SetText("")
--		icon.time:Show()
		if ci.db.char.layout[act].enabled then
			if ci.db.char.glob.enableConfig and iconT==ci.Icon_Nil then
				icon:Show()
			elseif iconT~=ci.Icon_Nil then
				icon:Show()
			else
				icon:Hide()
			end
		else icon:Hide()
		end
	end
	ci.btnsCreated=true
end

function ci:ACTIVE_TALENT_GROUP_CHANGED()
	ci.curTalentGroup = arg1
	ci:updateAllIcons(arg1)
end

function ci:updateAllIcons(newTal)
	--Update Icons, Reason of Dual-Spec swapping
	for i=1,ci.icons do
		local act = "icon"..i
		local curIcon = getglobal ("CI_"..act)
		local curTex = getglobal ("CI_"..act.."_Texture")
		local curTxt=getglobal("CI_"..act.."_time")
		local newSpell = ""
		local newIconPath = ci.Icon_Nil
		local curIsItem = ci.db.char.layout[act].isItem
		if newTal==1 then
			newSpell = ci.db.char.layout[act].id1
		elseif newTal==2 then
			newSpell = ci.db.char.layout[act].id2
		end
		local tmp = tonumber(newSpell)
		if tmp~=nil and newSpell~=0 then
			if curIsItem then
				_,_,_,_,_,_,_,_,_,newIconPath=GetItemInfo(tmp)
			else
				_,_,newIconPath = GetSpellInfo(tmp)
			end
		elseif newSpell~=0 and tmp==nil then
			if curIsItem then
				if (string.find(newSpell,"#")==1) then
					local invID = ci:equip_transferFlagToSpellName(newSpell)
					newIconPath=GetInventoryItemTexture("player",invID)
				else
					_,_,_,_,_,_,_,_,_,newIconPath=GetItemInfo(newSpell)
				end
			else
				_,_,newIconPath = GetSpellInfo(newSpell)
			end
		end
		curTex:SetTexture(newIconPath)
		curTxt:SetText("")
		if newIconPath==ci.Icon_Nil and not ci.db.char.glob.enableConfig then
			curIcon:Hide()
		else
			if ci.db.char.layout[act].enabled then
				curIcon:Show()
			end
		end
	end
end
function ci:PrintVersion()
	self:Print(self.ver)
end


function ci:equip_transferFlagToSpellName(flag)
	local v=0
	for i=0,#flags.equip do
		if (flags.equip[i]==flag) then
			v=i
		end
	end
	return v
end
